(function(){"use strict";try{if(typeof document!="undefined"){var e=document.createElement("style");e.appendChild(document.createTextNode(".mk-input{min-height:1.4em}.mk-input span{outline:none;white-space:pre-wrap}.mk-suggestions{border:1px solid #ccc;max-height:186px;overflow-y:auto;padding-left:0;position:absolute;background:white;width:fit-content;min-width:100px;margin-top:0;margin-bottom:0;transition:1.1s ease-out;filter:blur(0);transform:scale(1);opacity:1;visibility:visible;color:#000;border-radius:4%;box-shadow:0 3px 6px -2px #0009}.mk-suggestions li{padding:.5rem}.mk-suggestions li:hover,.mk-suggestion-active{background-color:#cce9ff;color:#2589f5;cursor:pointer}")),document.head.appendChild(e)}}catch(i){console.error("vite-plugin-css-injected-by-js",i)}})();
import Se, { useContext as Kt, Children as Gt, isValidElement as nt, useRef as G, useEffect as ie, useLayoutEffect as Ht, useState as ae, useCallback as J, memo as ct, useMemo as K, forwardRef as qt } from "react";
const Y = {
  UP: "ArrowUp",
  DOWN: "ArrowDown",
  LEFT: "ArrowLeft",
  RIGHT: "ArrowRight",
  END: "End",
  HOME: "Home",
  PAGE_DOWN: "PageDown",
  PAGE_UP: "PageUp",
  ENTER: "Enter",
  TAB: "Tab",
  SPACE: " ",
  BACKSPACE: "Backspace",
  DELETE: "Delete",
  COMMA: ",",
  ESC: "Escape"
};
var B = /* @__PURE__ */ ((r) => (r.LABEL = "__label__", r.VALUE = "__value__", r))(B || {});
const at = "mk-input", it = {
  trigger: "@",
  markup: "@[__label__](__value__)",
  data: [],
  index: 0
}, Jt = ["onFocus", "onBlur", "onKeyDown", "onClick"], Xt = new RegExp(/^\w*/);
class Zt {
  constructor(e, t) {
    this.raw = e, this.uniRegExp = t, this.done = !1;
  }
  [Symbol.iterator]() {
    return this;
  }
  next() {
    if (this.done)
      return { done: this.done, value: null };
    let e = this.uniRegExp.exec(this.raw);
    if (e === null)
      return this.done = !0, { done: !1, value: [this.raw, null] };
    let [t, n, i] = this.extractPieces(e);
    return this.raw = i, { done: !1, value: [t, n] };
  }
  extractPieces(e) {
    const t = this.extractMark(e), n = t.input.substring(0, t.index), i = t.input.substring(t.index + t.annotation.length);
    return [n, t, i];
  }
  extractMark(e) {
    let t = e[0], n = 0, i = e[1], o = e[2];
    for (; !(i || o); )
      n++, i = e[2 * n + 1], o = e[2 * n + 2];
    let c = e.index, l = e.input;
    return { annotation: t, label: i, value: o, input: l, index: c, childIndex: n };
  }
}
class pe {
  get regExps() {
    return this.markups.map(Qt);
  }
  static split(e, t) {
    const n = t.map((i) => i.markup);
    return () => new pe(n).split(e);
  }
  constructor(e) {
    this.markups = e, this.uniRegExp = new RegExp(this.regExps.map((t) => t.source).join("|"));
  }
  split(e) {
    return this.iterateMatches(e);
  }
  iterateMatches(e) {
    const t = [];
    for (let [n, i] of new Zt(e, this.uniRegExp))
      t.push(n), i !== null && t.push(er(i, this.markups[i.childIndex]));
    return t;
  }
}
const ft = Object.assign, Qt = (r) => {
  const e = he(r), t = r[r.indexOf(B.LABEL) + B.LABEL.length], n = r[r.indexOf(B.VALUE) + B.VALUE.length];
  return new RegExp(
    e.replace(B.LABEL, `([^${he(t || "")}]+?)`).replace(B.VALUE, `([^${he(n || "")}]+?)`)
  );
};
function Pe(r, e, t) {
  let n = r.replace(B.LABEL, e);
  return t ? n.replace(B.VALUE, t) : n;
}
function Kr(r, e, ...t) {
  return t.length ? new pe(t).split(r).reduce((i, o) => i += ge(o) ? e(o) : o, "") : r;
}
const he = (r) => r.replace(/[-[\]{}()*+?.,\\^$|#\s]/g, "\\$&");
function st(r, e) {
  let t = "";
  for (let n of r)
    t += dt(n) ? Pe(e[n.childIndex].markup, n.label, n.value) : n.label;
  return t;
}
const er = (r, e) => r.annotation !== Pe(e, r.label, r.value) ? { ...r, label: r.value, value: r.label } : r, ot = (r, e = 0) => {
  let t = 3735928559 ^ e, n = 1103547991 ^ e;
  for (let i = 0, o; i < r.length; i++)
    o = r.charCodeAt(i), t = Math.imul(t ^ o, 2654435761), n = Math.imul(n ^ o, 1597334677);
  return t = Math.imul(t ^ t >>> 16, 2246822507) ^ Math.imul(n ^ n >>> 13, 3266489909), n = Math.imul(n ^ n >>> 16, 2246822507) ^ Math.imul(t ^ t >>> 13, 3266489909), 4294967296 * (2097151 & n) + (t >>> 0);
}, ge = (r) => typeof r == "object", dt = (r) => r !== null && typeof r == "object" && "annotation" in r;
function tr(r) {
  if (!(r !== null && typeof r == "object" && "annotation" in r))
    throw new Error("Value is not annotated mark!");
}
const rr = (r) => typeof r == "function", nr = (r) => typeof r == "string" && r.startsWith("on"), ar = (r) => nt(r) ? !0 : nt(r == null ? void 0 : r[0]);
function ir(r) {
  if (ar(r))
    return Gt.map(r, (t, n) => e(t.props, n));
  if (r != null && r.length)
    return r.map(e);
  return [it];
  function e(t, n) {
    return ft({}, it, t, { index: n });
  }
}
const Te = (r) => {
  const e = Se.createContext(void 0);
  return e.displayName = r, [i(e), e];
  function i(o) {
    return () => {
      const c = Kt(o);
      if (c)
        return c;
      throw new Error(`The context ${o.displayName} didn't found!`);
    };
  }
}, [O, sr] = Te("MarkedInputStoreProvider"), [me, or] = Te("ValueProvider"), [ht, lr] = Te("NodeProvider");
function ur(r, e, t = !0) {
  let n;
  return () => {
    const o = t && !n;
    clearTimeout(n), n = setTimeout(i, e), o && r.apply(arguments);
  };
  function i() {
    n = void 0, t || r(arguments);
  }
}
function cr(r, e, t, n) {
  return r.slice(0, t) + e + r.slice(t + n.length);
}
function fr(r, e) {
  const t = ge(r) ? r.label + r.value : r;
  let n = 0, i = ot(t, n);
  for (; e != null && e.has(i); )
    i = ot(t, n++);
  return e == null || e.add(i), i;
}
class L {
  static get isSelectedPosition() {
    const e = window.getSelection();
    if (!!e)
      return e.isCollapsed;
  }
  static getCurrentPosition() {
    var e, t;
    return (t = (e = window.getSelection()) == null ? void 0 : e.anchorOffset) != null ? t : 0;
  }
  static getFocusedSpan() {
    var e, t, n;
    return (n = (t = (e = window.getSelection()) == null ? void 0 : e.anchorNode) == null ? void 0 : t.textContent) != null ? n : "";
  }
  static getSelectedNode() {
    var t;
    const e = (t = window.getSelection()) == null ? void 0 : t.anchorNode;
    if (e)
      return e;
    throw new Error("Anchor node of selection is not exists!");
  }
  static getAbsolutePosition() {
    var t, n, i;
    const e = (i = (t = window.getSelection()) == null ? void 0 : (n = t.getRangeAt(0)).getBoundingClientRect) == null ? void 0 : i.call(n);
    return e ? {
      left: e.left,
      top: e.top + e.height + 1
    } : {
      left: 0,
      top: 0
    };
  }
  static trySetIndex(e, t) {
    try {
      this.setIndex(e, t);
    } catch (n) {
      console.error(n);
    }
  }
  static setIndex(e, t) {
    const n = window.getSelection();
    if (!(n != null && n.anchorNode) || !n.rangeCount)
      return;
    const i = n.getRangeAt(0);
    i == null || i.setStart(e.firstChild || e, t), i == null || i.setEnd(e.firstChild || e, t);
  }
  static getCaretIndex(e) {
    let t = 0;
    const n = window.getSelection();
    if (!(n != null && n.rangeCount))
      return t;
    const i = n.getRangeAt(0), o = i.cloneRange();
    return o.selectNodeContents(e), o.setEnd(i.endContainer, i.endOffset), t = o.toString().length, t;
  }
  static setCaretToEnd(e) {
    if (!e)
      return;
    const t = window.getSelection();
    t == null || t.setPosition(e, 1);
  }
  static getIndex() {
    var t;
    const e = window.getSelection();
    return (t = e == null ? void 0 : e.anchorOffset) != null ? t : NaN;
  }
  static setIndex1(e) {
    const t = window.getSelection();
    if (!(t != null && t.anchorNode) || !t.rangeCount)
      return;
    const n = t.getRangeAt(0);
    n == null || n.setStart(n.startContainer.firstChild || n.startContainer, e), n == null || n.setEnd(n.startContainer.firstChild || n.startContainer, e);
  }
  setCaretRightTo(e, t) {
    const n = window.getSelection(), i = n == null ? void 0 : n.getRangeAt(0);
    i == null || i.setStart(i.endContainer, t), i == null || i.setEnd(i.endContainer, t);
  }
}
const dr = () => {
  const r = me(), e = G(null);
  return ie(() => {
    var t, n;
    if (e.current) {
      const {
        prevNodeData: i,
        caretPosition: o
      } = e.current, c = r.findNode((p) => p === i), l = (t = c == null ? void 0 : c.next) != null ? t : r.head, f = (n = l == null ? void 0 : l.data.ref) == null ? void 0 : n.current;
      f == null || f.focus(), f && L.trySetIndex(f, o), e.current = null;
    }
  }), e;
};
function F(r, e, t, n) {
  const {
    bus: i
  } = n != null ? n : O();
  ie(() => i.listen(r, e), t);
}
const hr = () => {
  const r = me(), e = G();
  return F("onFocus", (t) => e.current = r.findNode((n) => {
    var i;
    return ((i = n.ref) == null ? void 0 : i.current) === t.target;
  }), [r]), F("onBlur", (t) => e.current = void 0, []), e;
};
var R = /* @__PURE__ */ ((r) => (r[r.Change = 0] = "Change", r[r.Delete = 1] = "Delete", r[r.CheckTrigger = 2] = "CheckTrigger", r[r.ClearTrigger = 3] = "ClearTrigger", r[r.Select = 4] = "Select", r))(R || {});
function vr(r, e) {
  const {
    bus: t
  } = O();
  F("onKeyDown", (n) => {
    var A, M;
    const i = n.target, o = L.getCaretIndex(i), c = o === 0, l = o === ((A = i.textContent) == null ? void 0 : A.length), f = {
      [Y.LEFT]: c ? p : null,
      [Y.RIGHT]: l ? E : null,
      [Y.UP]: null,
      [Y.DOWN]: null,
      [Y.DELETE]: l ? k : null,
      [Y.BACKSPACE]: c ? C : null
    };
    (M = f[n.key]) == null || M.call(f);
    function p() {
      var _, x, N, D, I;
      const m = (_ = e.current) == null ? void 0 : _.prev, T = (I = (x = m == null ? void 0 : m.data.ref) == null ? void 0 : x.current) != null ? I : (D = (N = m == null ? void 0 : m.prev) == null ? void 0 : N.data.ref) == null ? void 0 : D.current;
      T == null || T.focus(), L.setCaretToEnd(T), n.preventDefault();
    }
    function E() {
      var _, x, N, D, I;
      const m = (_ = e.current) == null ? void 0 : _.next, T = (I = (x = m == null ? void 0 : m.data.ref) == null ? void 0 : x.current) != null ? I : (D = (N = m == null ? void 0 : m.next) == null ? void 0 : N.data.ref) == null ? void 0 : D.current;
      T == null || T.focus(), n.preventDefault();
    }
    function C() {
      var _, x, N, D, I;
      const m = (_ = e.current) == null ? void 0 : _.prev;
      if (!(m != null && m.data.key))
        return;
      const T = (N = (x = m.prev) == null ? void 0 : x.data.mark.label.length) != null ? N : 0;
      r.current = {
        prevNodeData: (I = (D = m.prev) == null ? void 0 : D.prev) == null ? void 0 : I.data,
        caretPosition: T
      }, t.send(R.Delete, {
        key: m.data.key
      }), n.preventDefault();
    }
    function k() {
      var _, x, N, D, I;
      const m = (_ = e.current) == null ? void 0 : _.next;
      if (!(m != null && m.data.key))
        return;
      const T = (N = (x = m.prev) == null ? void 0 : x.data.mark.label.length) != null ? N : 0;
      r.current = {
        prevNodeData: (I = (D = m.prev) == null ? void 0 : D.prev) == null ? void 0 : I.data,
        caretPosition: T
      }, t.send(R.Delete, {
        key: m.data.key
      }), n.preventDefault();
    }
  }, []);
}
const pr = () => {
  const r = me();
  F("onClick", () => {
    var e, t, n, i;
    r.length === 1 && ((e = r.head) == null ? void 0 : e.data.mark.label) === "" && ((i = (n = (t = r.head) == null ? void 0 : t.data.ref) == null ? void 0 : n.current) == null || i.focus());
  }, [r]);
}, gr = () => {
  const r = hr(), e = dr();
  vr(e, r), pr();
};
function mr() {
  const {
    bus: r
  } = O(), e = G(null);
  return ie(() => r.set("TextRef", e), []), e;
}
var Oe = { exports: {} }, Q = {};
/**
 * @license React
 * react-jsx-runtime.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var lt;
function Er() {
  if (lt)
    return Q;
  lt = 1;
  var r = Se, e = Symbol.for("react.element"), t = Symbol.for("react.fragment"), n = Object.prototype.hasOwnProperty, i = r.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentOwner, o = { key: !0, ref: !0, __self: !0, __source: !0 };
  function c(l, f, p) {
    var E, C = {}, k = null, A = null;
    p !== void 0 && (k = "" + p), f.key !== void 0 && (k = "" + f.key), f.ref !== void 0 && (A = f.ref);
    for (E in f)
      n.call(f, E) && !o.hasOwnProperty(E) && (C[E] = f[E]);
    if (l && l.defaultProps)
      for (E in f = l.defaultProps, f)
        C[E] === void 0 && (C[E] = f[E]);
    return { $$typeof: e, type: l, key: k, ref: A, props: C, _owner: i.current };
  }
  return Q.Fragment = t, Q.jsx = c, Q.jsxs = c, Q;
}
var ee = {};
/**
 * @license React
 * react-jsx-runtime.development.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var ut;
function xr() {
  return ut || (ut = 1, process.env.NODE_ENV !== "production" && function() {
    var r = Se, e = Symbol.for("react.element"), t = Symbol.for("react.portal"), n = Symbol.for("react.fragment"), i = Symbol.for("react.strict_mode"), o = Symbol.for("react.profiler"), c = Symbol.for("react.provider"), l = Symbol.for("react.context"), f = Symbol.for("react.forward_ref"), p = Symbol.for("react.suspense"), E = Symbol.for("react.suspense_list"), C = Symbol.for("react.memo"), k = Symbol.for("react.lazy"), A = Symbol.for("react.offscreen"), M = Symbol.iterator, m = "@@iterator";
    function T(a) {
      if (a === null || typeof a != "object")
        return null;
      var s = M && a[M] || a[m];
      return typeof s == "function" ? s : null;
    }
    var _ = r.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED;
    function x(a) {
      {
        for (var s = arguments.length, u = new Array(s > 1 ? s - 1 : 0), d = 1; d < s; d++)
          u[d - 1] = arguments[d];
        N("error", a, u);
      }
    }
    function N(a, s, u) {
      {
        var d = _.ReactDebugCurrentFrame, g = d.getStackAddendum();
        g !== "" && (s += "%s", u = u.concat([g]));
        var w = u.map(function(v) {
          return String(v);
        });
        w.unshift("Warning: " + s), Function.prototype.apply.call(console[a], console, w);
      }
    }
    var D = !1, I = !1, gt = !1, mt = !1, Et = !1, De;
    De = Symbol.for("react.module.reference");
    function xt(a) {
      return !!(typeof a == "string" || typeof a == "function" || a === n || a === o || Et || a === i || a === p || a === E || mt || a === A || D || I || gt || typeof a == "object" && a !== null && (a.$$typeof === k || a.$$typeof === C || a.$$typeof === c || a.$$typeof === l || a.$$typeof === f || a.$$typeof === De || a.getModuleId !== void 0));
    }
    function wt(a, s, u) {
      var d = a.displayName;
      if (d)
        return d;
      var g = s.displayName || s.name || "";
      return g !== "" ? u + "(" + g + ")" : u;
    }
    function Ie(a) {
      return a.displayName || "Context";
    }
    function W(a) {
      if (a == null)
        return null;
      if (typeof a.tag == "number" && x("Received an unexpected object in getComponentNameFromType(). This is likely a bug in React. Please file an issue."), typeof a == "function")
        return a.displayName || a.name || null;
      if (typeof a == "string")
        return a;
      switch (a) {
        case n:
          return "Fragment";
        case t:
          return "Portal";
        case o:
          return "Profiler";
        case i:
          return "StrictMode";
        case p:
          return "Suspense";
        case E:
          return "SuspenseList";
      }
      if (typeof a == "object")
        switch (a.$$typeof) {
          case l:
            var s = a;
            return Ie(s) + ".Consumer";
          case c:
            var u = a;
            return Ie(u._context) + ".Provider";
          case f:
            return wt(a, a.render, "ForwardRef");
          case C:
            var d = a.displayName || null;
            return d !== null ? d : W(a.type) || "Memo";
          case k: {
            var g = a, w = g._payload, v = g._init;
            try {
              return W(v(w));
            } catch {
              return null;
            }
          }
        }
      return null;
    }
    var U = Object.assign, X = 0, je, Fe, Le, Me, We, $e, Be;
    function Ve() {
    }
    Ve.__reactDisabledLog = !0;
    function yt() {
      {
        if (X === 0) {
          je = console.log, Fe = console.info, Le = console.warn, Me = console.error, We = console.group, $e = console.groupCollapsed, Be = console.groupEnd;
          var a = {
            configurable: !0,
            enumerable: !0,
            value: Ve,
            writable: !0
          };
          Object.defineProperties(console, {
            info: a,
            log: a,
            warn: a,
            error: a,
            group: a,
            groupCollapsed: a,
            groupEnd: a
          });
        }
        X++;
      }
    }
    function bt() {
      {
        if (X--, X === 0) {
          var a = {
            configurable: !0,
            enumerable: !0,
            writable: !0
          };
          Object.defineProperties(console, {
            log: U({}, a, {
              value: je
            }),
            info: U({}, a, {
              value: Fe
            }),
            warn: U({}, a, {
              value: Le
            }),
            error: U({}, a, {
              value: Me
            }),
            group: U({}, a, {
              value: We
            }),
            groupCollapsed: U({}, a, {
              value: $e
            }),
            groupEnd: U({}, a, {
              value: Be
            })
          });
        }
        X < 0 && x("disabledDepth fell below zero. This is a bug in React. Please file an issue.");
      }
    }
    var Ee = _.ReactCurrentDispatcher, xe;
    function se(a, s, u) {
      {
        if (xe === void 0)
          try {
            throw Error();
          } catch (g) {
            var d = g.stack.trim().match(/\n( *(at )?)/);
            xe = d && d[1] || "";
          }
        return `
` + xe + a;
      }
    }
    var we = !1, oe;
    {
      var Ct = typeof WeakMap == "function" ? WeakMap : Map;
      oe = new Ct();
    }
    function Ue(a, s) {
      if (!a || we)
        return "";
      {
        var u = oe.get(a);
        if (u !== void 0)
          return u;
      }
      var d;
      we = !0;
      var g = Error.prepareStackTrace;
      Error.prepareStackTrace = void 0;
      var w;
      w = Ee.current, Ee.current = null, yt();
      try {
        if (s) {
          var v = function() {
            throw Error();
          };
          if (Object.defineProperty(v.prototype, "props", {
            set: function() {
              throw Error();
            }
          }), typeof Reflect == "object" && Reflect.construct) {
            try {
              Reflect.construct(v, []);
            } catch ($) {
              d = $;
            }
            Reflect.construct(a, [], v);
          } else {
            try {
              v.call();
            } catch ($) {
              d = $;
            }
            a.call(v.prototype);
          }
        } else {
          try {
            throw Error();
          } catch ($) {
            d = $;
          }
          a();
        }
      } catch ($) {
        if ($ && d && typeof $.stack == "string") {
          for (var h = $.stack.split(`
`), S = d.stack.split(`
`), y = h.length - 1, b = S.length - 1; y >= 1 && b >= 0 && h[y] !== S[b]; )
            b--;
          for (; y >= 1 && b >= 0; y--, b--)
            if (h[y] !== S[b]) {
              if (y !== 1 || b !== 1)
                do
                  if (y--, b--, b < 0 || h[y] !== S[b]) {
                    var j = `
` + h[y].replace(" at new ", " at ");
                    return a.displayName && j.includes("<anonymous>") && (j = j.replace("<anonymous>", a.displayName)), typeof a == "function" && oe.set(a, j), j;
                  }
                while (y >= 1 && b >= 0);
              break;
            }
        }
      } finally {
        we = !1, Ee.current = w, bt(), Error.prepareStackTrace = g;
      }
      var q = a ? a.displayName || a.name : "", rt = q ? se(q) : "";
      return typeof a == "function" && oe.set(a, rt), rt;
    }
    function _t(a, s, u) {
      return Ue(a, !1);
    }
    function Rt(a) {
      var s = a.prototype;
      return !!(s && s.isReactComponent);
    }
    function le(a, s, u) {
      if (a == null)
        return "";
      if (typeof a == "function")
        return Ue(a, Rt(a));
      if (typeof a == "string")
        return se(a);
      switch (a) {
        case p:
          return se("Suspense");
        case E:
          return se("SuspenseList");
      }
      if (typeof a == "object")
        switch (a.$$typeof) {
          case f:
            return _t(a.render);
          case C:
            return le(a.type, s, u);
          case k: {
            var d = a, g = d._payload, w = d._init;
            try {
              return le(w(g), s, u);
            } catch {
            }
          }
        }
      return "";
    }
    var ue = Object.prototype.hasOwnProperty, Ye = {}, ze = _.ReactDebugCurrentFrame;
    function ce(a) {
      if (a) {
        var s = a._owner, u = le(a.type, a._source, s ? s.type : null);
        ze.setExtraStackFrame(u);
      } else
        ze.setExtraStackFrame(null);
    }
    function kt(a, s, u, d, g) {
      {
        var w = Function.call.bind(ue);
        for (var v in a)
          if (w(a, v)) {
            var h = void 0;
            try {
              if (typeof a[v] != "function") {
                var S = Error((d || "React class") + ": " + u + " type `" + v + "` is invalid; it must be a function, usually from the `prop-types` package, but received `" + typeof a[v] + "`.This often happens because of typos such as `PropTypes.function` instead of `PropTypes.func`.");
                throw S.name = "Invariant Violation", S;
              }
              h = a[v](s, v, d, u, null, "SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED");
            } catch (y) {
              h = y;
            }
            h && !(h instanceof Error) && (ce(g), x("%s: type specification of %s `%s` is invalid; the type checker function must return `null` or an `Error` but returned a %s. You may have forgotten to pass an argument to the type checker creator (arrayOf, instanceOf, objectOf, oneOf, oneOfType, and shape all require an argument).", d || "React class", u, v, typeof h), ce(null)), h instanceof Error && !(h.message in Ye) && (Ye[h.message] = !0, ce(g), x("Failed %s type: %s", u, h.message), ce(null));
          }
      }
    }
    var St = Array.isArray;
    function ye(a) {
      return St(a);
    }
    function Pt(a) {
      {
        var s = typeof Symbol == "function" && Symbol.toStringTag, u = s && a[Symbol.toStringTag] || a.constructor.name || "Object";
        return u;
      }
    }
    function Tt(a) {
      try {
        return Ke(a), !1;
      } catch {
        return !0;
      }
    }
    function Ke(a) {
      return "" + a;
    }
    function Ge(a) {
      if (Tt(a))
        return x("The provided key is an unsupported type %s. This value must be coerced to a string before before using it here.", Pt(a)), Ke(a);
    }
    var Z = _.ReactCurrentOwner, Ot = {
      key: !0,
      ref: !0,
      __self: !0,
      __source: !0
    }, He, qe, be;
    be = {};
    function At(a) {
      if (ue.call(a, "ref")) {
        var s = Object.getOwnPropertyDescriptor(a, "ref").get;
        if (s && s.isReactWarning)
          return !1;
      }
      return a.ref !== void 0;
    }
    function Nt(a) {
      if (ue.call(a, "key")) {
        var s = Object.getOwnPropertyDescriptor(a, "key").get;
        if (s && s.isReactWarning)
          return !1;
      }
      return a.key !== void 0;
    }
    function Dt(a, s) {
      if (typeof a.ref == "string" && Z.current && s && Z.current.stateNode !== s) {
        var u = W(Z.current.type);
        be[u] || (x('Component "%s" contains the string ref "%s". Support for string refs will be removed in a future major release. This case cannot be automatically converted to an arrow function. We ask you to manually fix this case by using useRef() or createRef() instead. Learn more about using refs safely here: https://reactjs.org/link/strict-mode-string-ref', W(Z.current.type), a.ref), be[u] = !0);
      }
    }
    function It(a, s) {
      {
        var u = function() {
          He || (He = !0, x("%s: `key` is not a prop. Trying to access it will result in `undefined` being returned. If you need to access the same value within the child component, you should pass it as a different prop. (https://reactjs.org/link/special-props)", s));
        };
        u.isReactWarning = !0, Object.defineProperty(a, "key", {
          get: u,
          configurable: !0
        });
      }
    }
    function jt(a, s) {
      {
        var u = function() {
          qe || (qe = !0, x("%s: `ref` is not a prop. Trying to access it will result in `undefined` being returned. If you need to access the same value within the child component, you should pass it as a different prop. (https://reactjs.org/link/special-props)", s));
        };
        u.isReactWarning = !0, Object.defineProperty(a, "ref", {
          get: u,
          configurable: !0
        });
      }
    }
    var Ft = function(a, s, u, d, g, w, v) {
      var h = {
        $$typeof: e,
        type: a,
        key: s,
        ref: u,
        props: v,
        _owner: w
      };
      return h._store = {}, Object.defineProperty(h._store, "validated", {
        configurable: !1,
        enumerable: !1,
        writable: !0,
        value: !1
      }), Object.defineProperty(h, "_self", {
        configurable: !1,
        enumerable: !1,
        writable: !1,
        value: d
      }), Object.defineProperty(h, "_source", {
        configurable: !1,
        enumerable: !1,
        writable: !1,
        value: g
      }), Object.freeze && (Object.freeze(h.props), Object.freeze(h)), h;
    };
    function Lt(a, s, u, d, g) {
      {
        var w, v = {}, h = null, S = null;
        u !== void 0 && (Ge(u), h = "" + u), Nt(s) && (Ge(s.key), h = "" + s.key), At(s) && (S = s.ref, Dt(s, g));
        for (w in s)
          ue.call(s, w) && !Ot.hasOwnProperty(w) && (v[w] = s[w]);
        if (a && a.defaultProps) {
          var y = a.defaultProps;
          for (w in y)
            v[w] === void 0 && (v[w] = y[w]);
        }
        if (h || S) {
          var b = typeof a == "function" ? a.displayName || a.name || "Unknown" : a;
          h && It(v, b), S && jt(v, b);
        }
        return Ft(a, h, S, g, d, Z.current, v);
      }
    }
    var Ce = _.ReactCurrentOwner, Je = _.ReactDebugCurrentFrame;
    function H(a) {
      if (a) {
        var s = a._owner, u = le(a.type, a._source, s ? s.type : null);
        Je.setExtraStackFrame(u);
      } else
        Je.setExtraStackFrame(null);
    }
    var _e;
    _e = !1;
    function Re(a) {
      return typeof a == "object" && a !== null && a.$$typeof === e;
    }
    function Xe() {
      {
        if (Ce.current) {
          var a = W(Ce.current.type);
          if (a)
            return `

Check the render method of \`` + a + "`.";
        }
        return "";
      }
    }
    function Mt(a) {
      {
        if (a !== void 0) {
          var s = a.fileName.replace(/^.*[\\\/]/, ""), u = a.lineNumber;
          return `

Check your code at ` + s + ":" + u + ".";
        }
        return "";
      }
    }
    var Ze = {};
    function Wt(a) {
      {
        var s = Xe();
        if (!s) {
          var u = typeof a == "string" ? a : a.displayName || a.name;
          u && (s = `

Check the top-level render call using <` + u + ">.");
        }
        return s;
      }
    }
    function Qe(a, s) {
      {
        if (!a._store || a._store.validated || a.key != null)
          return;
        a._store.validated = !0;
        var u = Wt(s);
        if (Ze[u])
          return;
        Ze[u] = !0;
        var d = "";
        a && a._owner && a._owner !== Ce.current && (d = " It was passed a child from " + W(a._owner.type) + "."), H(a), x('Each child in a list should have a unique "key" prop.%s%s See https://reactjs.org/link/warning-keys for more information.', u, d), H(null);
      }
    }
    function et(a, s) {
      {
        if (typeof a != "object")
          return;
        if (ye(a))
          for (var u = 0; u < a.length; u++) {
            var d = a[u];
            Re(d) && Qe(d, s);
          }
        else if (Re(a))
          a._store && (a._store.validated = !0);
        else if (a) {
          var g = T(a);
          if (typeof g == "function" && g !== a.entries)
            for (var w = g.call(a), v; !(v = w.next()).done; )
              Re(v.value) && Qe(v.value, s);
        }
      }
    }
    function $t(a) {
      {
        var s = a.type;
        if (s == null || typeof s == "string")
          return;
        var u;
        if (typeof s == "function")
          u = s.propTypes;
        else if (typeof s == "object" && (s.$$typeof === f || s.$$typeof === C))
          u = s.propTypes;
        else
          return;
        if (u) {
          var d = W(s);
          kt(u, a.props, "prop", d, a);
        } else if (s.PropTypes !== void 0 && !_e) {
          _e = !0;
          var g = W(s);
          x("Component %s declared `PropTypes` instead of `propTypes`. Did you misspell the property assignment?", g || "Unknown");
        }
        typeof s.getDefaultProps == "function" && !s.getDefaultProps.isReactClassApproved && x("getDefaultProps is only used on classic React.createClass definitions. Use a static property named `defaultProps` instead.");
      }
    }
    function Bt(a) {
      {
        for (var s = Object.keys(a.props), u = 0; u < s.length; u++) {
          var d = s[u];
          if (d !== "children" && d !== "key") {
            H(a), x("Invalid prop `%s` supplied to `React.Fragment`. React.Fragment can only have `key` and `children` props.", d), H(null);
            break;
          }
        }
        a.ref !== null && (H(a), x("Invalid attribute `ref` supplied to `React.Fragment`."), H(null));
      }
    }
    function tt(a, s, u, d, g, w) {
      {
        var v = xt(a);
        if (!v) {
          var h = "";
          (a === void 0 || typeof a == "object" && a !== null && Object.keys(a).length === 0) && (h += " You likely forgot to export your component from the file it's defined in, or you might have mixed up default and named imports.");
          var S = Mt(g);
          S ? h += S : h += Xe();
          var y;
          a === null ? y = "null" : ye(a) ? y = "array" : a !== void 0 && a.$$typeof === e ? (y = "<" + (W(a.type) || "Unknown") + " />", h = " Did you accidentally export a JSX literal instead of a component?") : y = typeof a, x("React.jsx: type is invalid -- expected a string (for built-in components) or a class/function (for composite components) but got: %s.%s", y, h);
        }
        var b = Lt(a, s, u, g, w);
        if (b == null)
          return b;
        if (v) {
          var j = s.children;
          if (j !== void 0)
            if (d)
              if (ye(j)) {
                for (var q = 0; q < j.length; q++)
                  et(j[q], a);
                Object.freeze && Object.freeze(j);
              } else
                x("React.jsx: Static children should always be an array. You are likely explicitly calling React.jsxs or React.jsxDEV. Use the Babel transform instead.");
            else
              et(j, a);
        }
        return a === n ? Bt(b) : $t(b), b;
      }
    }
    function Vt(a, s, u) {
      return tt(a, s, u, !0);
    }
    function Ut(a, s, u) {
      return tt(a, s, u, !1);
    }
    var Yt = Ut, zt = Vt;
    ee.Fragment = n, ee.jsx = Yt, ee.jsxs = zt;
  }()), ee;
}
(function(r) {
  process.env.NODE_ENV === "production" ? r.exports = Er() : r.exports = xr();
})(Oe);
const P = Oe.exports.jsx, wr = Oe.exports.jsxs;
function yr() {
  var o, c, l;
  const {
    mark: r
  } = ht(), {
    options: e,
    props: {
      Mark: t
    }
  } = O();
  tr(r);
  const n = {
    label: r.label,
    value: r.value
  }, i = (l = (c = (o = e[r.childIndex]).initMark) == null ? void 0 : c.call(o, n)) != null ? l : n;
  return /* @__PURE__ */ P(t, {
    ...i
  });
}
const br = () => {
  const r = G(NaN);
  return Ht(() => {
    Number.isNaN(r.current) || e();
  }), t;
  function e() {
    var i;
    const n = (i = window.getSelection()) == null ? void 0 : i.anchorNode;
    n && L.trySetIndex(n, r.current), r.current = NaN;
  }
  function t(n) {
    r.current = L.getCaretIndex(n);
  }
}, Cr = () => {
  const r = ht(), { bus: e, props: { readOnly: t, spanStyle: n, spanClassName: i } } = O(), o = _r(r), [c, l] = ae(r.mark.label), [f, p] = ae(r.mark.value), E = J((A, M) => {
    M != null && M.silent || (l(A.label), p(A.value)), e.send(R.Change, { key: r.key, value: { ...A } });
  }, []), C = J(() => {
    l(""), p(void 0), e.send(R.Delete, { key: r.key });
  }, []), k = br();
  return { label: c, value: f, reg: o, onChange: E, onRemove: C, heldCaret: k, readOnly: t, style: n, className: i };
};
function _r(r) {
  const e = G(null);
  return J((t) => {
    if (t && "current" in t) {
      r.ref = t;
      return;
    }
    e.current = t, r.ref = e;
  }, []);
}
const Rr = () => {
  const {
    label: r,
    reg: e,
    onChange: t,
    heldCaret: n,
    className: i,
    style: o,
    readOnly: c
  } = Cr();
  return /* @__PURE__ */ P("span", {
    ref: e,
    style: o,
    className: i,
    contentEditable: !c,
    suppressContentEditableWarning: !0,
    onInput: (f) => {
      var E;
      n(f.currentTarget);
      const p = (E = f.currentTarget.textContent) != null ? E : "";
      t({
        label: p
      }, {
        silent: !0
      });
    },
    onPaste: kr,
    children: r
  });
};
function kr(r) {
  r.preventDefault();
  const e = r.clipboardData.getData("text");
  document.execCommand("insertText", !1, e);
}
const Sr = ct(() => {
  const {
    bus: r,
    props: {
      className: e,
      style: t
    }
  } = O(), n = e ? at + " " + e : at, i = mr(), o = K(() => r.events, []), c = me();
  return gr(), /* @__PURE__ */ P("div", {
    ref: i,
    className: n,
    style: t,
    ...o,
    children: c.toArray().map((l) => /* @__PURE__ */ P(lr.Provider, {
      value: l,
      children: dt(l.mark) ? /* @__PURE__ */ P(yr, {}) : /* @__PURE__ */ P(Rr, {})
    }, l.key))
  });
}), Pr = (r) => K(() => ir(r), [r]);
class fe {
  constructor(e, t, n, i) {
    this.data = e, this.prev = t, this.next = n, this.list = i;
  }
  get index() {
    if (!!this.list)
      return this.list.findIndex((e) => e === this.data);
  }
  insertBefore(e) {
    return this.list !== null ? this.list.insertBefore(this, e) : new V(e, this.data);
  }
  insertAfter(e) {
    return this.list !== null ? this.list.insertAfter(this, e) : new V(this.data, e);
  }
  remove() {
    if (this.list === null)
      throw new ReferenceError("Node does not belong to any list");
    return this.list.removeNode(this);
  }
}
class V {
  get length() {
    return this.size;
  }
  static from(e) {
    return new V(...e);
  }
  constructor(...e) {
    this.head = null, this.tail = null, this.size = 0;
    for (let t = 0; t < arguments.length; t++)
      this.append(arguments[t]);
  }
  get(e) {
    const t = this.getNode(e);
    return t !== void 0 ? t.data : void 0;
  }
  getNode(e) {
    if (this.head === null || e < 0 || e >= this.length)
      return;
    const t = e < this.length / 2, n = t ? e : this.length - e - 1, i = t ? "next" : "prev";
    let o = t ? this.head : this.tail;
    for (let c = 0; c < n; c++)
      o = o[i];
    return o;
  }
  findNodeIndex(e) {
    let t = 0, n = this.head;
    for (; n; ) {
      if (e(n.data, t, this))
        return {
          index: t,
          node: n
        };
      n = n.next, t += 1;
    }
  }
  findNode(e) {
    const t = this.findNodeIndex(e);
    return t !== void 0 ? t.node : void 0;
  }
  find(e) {
    const t = this.findNodeIndex(e);
    return t !== void 0 ? t.node.data : void 0;
  }
  findIndex(e) {
    const t = this.findNodeIndex(e);
    return t !== void 0 ? t.index : -1;
  }
  append(...e) {
    for (const t of e) {
      const n = new fe(t, this.tail, null, this);
      this.head === null && (this.head = n), this.tail !== null && (this.tail.next = n), this.tail = n, this.size += 1;
    }
    return this;
  }
  prepend(...e) {
    const t = Array.from(e).reverse();
    for (const n of t) {
      const i = new fe(n, null, this.head, this);
      this.tail === null && (this.tail = i), this.head !== null && (this.head.prev = i), this.head = i, this.size += 1;
    }
    return this;
  }
  insertAt(e, t) {
    if (this.head === null)
      return this.append(t);
    if (e <= 0)
      return this.prepend(t);
    let n = this.head, i = 0;
    for (; i < e - 1 && n.next !== null; )
      i += 1, n = n.next;
    return n.insertAfter(t), this;
  }
  removeNode(e) {
    if (e.list !== this)
      throw new ReferenceError("Node does not belong to this list");
    return e.prev !== null && (e.prev.next = e.next), e.next !== null && (e.next.prev = e.prev), this.head === e && (this.head = e.next), this.tail === e && (this.tail = e.prev), this.size -= 1, e.next = null, e.prev = null, e.list = null, e;
  }
  removeAt(e) {
    const t = this.getNode(e);
    return t !== void 0 ? this.removeNode(t) : void 0;
  }
  insertBefore(e, t) {
    const n = new fe(t, e.prev, e, this);
    return e.prev === null && (this.head = n), e.prev !== null && (e.prev.next = n), e.prev = n, this.size += 1, this;
  }
  sort(e) {
    if (this.head === null || this.tail === null)
      return this;
    if (this.length < 2)
      return this;
    const t = (n, i) => {
      if (n === i)
        return;
      const o = i.data;
      let c = n, l = n;
      for (; c && c !== i; ) {
        if (e(c.data, o)) {
          if (c !== l) {
            const p = l.data;
            l.data = c.data, c.data = p;
          }
          l = l.next;
        }
        c = c.next;
      }
      i.data = l.data, l.data = o, n.next !== i.prev && (l.prev && l !== n && t(n, l.prev), l.next && l !== i && t(l.next, i));
    };
    return t(this.head, this.tail), this;
  }
  insertAfter(e, t) {
    const n = new fe(t, e, e.next, this);
    return e.next === null && (this.tail = n), e.next !== null && (e.next.prev = n), e.next = n, this.size += 1, this;
  }
  shift() {
    return this.removeFromAnyEnd(this.head);
  }
  pop() {
    return this.removeFromAnyEnd(this.tail);
  }
  merge(e) {
    this.tail !== null && (this.tail.next = e.head), e.head !== null && (e.head.prev = this.tail), this.head = this.head || e.head, this.tail = e.tail || this.tail, this.size += e.size, e.size = this.size, e.head = this.head, e.tail = this.tail;
  }
  clear() {
    return this.head = null, this.tail = null, this.size = 0, this;
  }
  slice(e, t) {
    const n = new V();
    let i = t;
    if (this.head === null || this.tail === null)
      return n;
    (i === void 0 || i < e) && (i = this.length);
    let o = this.getNode(e);
    for (let c = 0; c < i - e && o !== null && o !== void 0; c++)
      n.append(o.data), o = o.next;
    return n;
  }
  reverse() {
    let e = this.head;
    for (; e; ) {
      const n = e.next;
      e.next = e.prev, e.prev = n, e = e.prev;
    }
    const t = this.tail;
    return this.tail = this.head, this.head = t, this;
  }
  forEach(e, t = !1) {
    let n = t ? this.length - 1 : 0, i = t ? this.tail : this.head;
    const o = t ? -1 : 1, c = t ? "prev" : "next";
    for (; i; )
      e(i.data, n, this), i = i[c], n += o;
  }
  map(e, t = !1) {
    const n = new V();
    return this.forEach((i, o) => n.append(e(i, o, this)), t), n;
  }
  filter(e, t = !1) {
    const n = new V();
    return this.forEach((i, o) => {
      e(i, o, this) && n.append(i);
    }, t), n;
  }
  reduce(e, t, n = !1) {
    let i = n ? this.length - 1 : 0;
    const o = n ? -1 : 1, c = n ? "prev" : "next";
    let l = n ? this.tail : this.head, f;
    if (t !== void 0)
      f = t;
    else if (l)
      f = l.data, l = l[c];
    else
      throw new TypeError("Reduce of empty LinkedList with no initial value");
    for (; l; )
      f = e(f, l.data, i, this), i += o, l = l[c];
    return f;
  }
  toArray() {
    return [...this];
  }
  toString(e = " ") {
    return this.reduce((t, n) => `${t}${e}${n}`);
  }
  *[Symbol.iterator]() {
    let e = this.head;
    for (; e !== null; )
      yield e.data, e = e.next;
  }
  removeFromAnyEnd(e) {
    return e !== null ? this.removeNode(e).data : void 0;
  }
}
const Tr = (r, e) => {
  const t = K(pe.split(r, e), [r]), n = G(null);
  return K(() => {
    const i = /* @__PURE__ */ new Set(), o = t.map((c) => {
      var p;
      let l = fr(c, i);
      const f = (p = n.current) == null ? void 0 : p.findNode((E) => E.key === l);
      return !f || Or(c, f) && l++ ? { key: l, mark: ge(c) ? c : { label: c } } : f.data;
    });
    return n.current = V.from(o), n.current;
  }, [t.length]);
}, Or = (r, e) => ge(r) ? !1 : e.data.mark.label !== r;
var vt = (r, e, t) => {
  if (!e.has(r))
    throw TypeError("Cannot " + t);
}, z = (r, e, t) => (vt(r, e, "read from private field"), t ? t.call(r) : e.get(r)), de = (r, e, t) => {
  if (e.has(r))
    throw TypeError("Cannot add the same private member more than once");
  e instanceof WeakSet ? e.add(r) : e.set(r, t);
}, ke = (r, e, t) => (vt(r, e, "access private method"), t), Ae, ne, te, re, ve;
const pt = class {
  constructor(...r) {
    de(this, re), de(this, Ae, /* @__PURE__ */ new Map()), de(this, ne, /* @__PURE__ */ new Map()), de(this, te, {}), r.forEach((e) => z(this, ne).set(e, /* @__PURE__ */ new Set()));
  }
  get events() {
    let r = {};
    for (let e of z(this, ne).keys())
      r[e] = (t) => this.send(e, t);
    return r;
  }
  static withExternalEventsFrom(r) {
    const e = new Set(Jt);
    return () => new pt(...e);
  }
  get(r) {
    if (z(this, te)[r])
      return z(this, te)[r];
    throw new Error(`The ${r} is not exist!`);
  }
  set(r, e) {
    z(this, te)[r] = e;
  }
  send(r, e) {
    ke(this, re, ve).call(this, r).forEach((t) => t(e));
  }
  listen(r, e) {
    return ke(this, re, ve).call(this, r).add(e), () => ke(this, re, ve).call(this, r).delete(e);
  }
};
let Ar = pt;
Ae = /* @__PURE__ */ new WeakMap();
ne = /* @__PURE__ */ new WeakMap();
te = /* @__PURE__ */ new WeakMap();
re = /* @__PURE__ */ new WeakSet();
ve = function(r) {
  const e = nr(r) ? z(this, ne) : z(this, Ae);
  return e.has(r) || e.set(r, /* @__PURE__ */ new Set()), e.get(r);
};
function Nr(r, e) {
  const {
    bus: t,
    options: n
  } = O();
  F(R.Change, (i) => {
    const {
      key: o,
      value: c
    } = i, l = e.find((p) => p.key === o);
    l && c && (l.mark.label = c.label, l.mark.value = c.value);
    const f = e.toArray().map((p) => p.mark);
    r(st(f, n));
  }, [e, r]), F(R.Delete, (i) => {
    const {
      key: o
    } = i, c = e.findNode((f) => f.key === o);
    c && c.remove();
    const l = e.toArray().map((f) => f.mark);
    r(st(l, n));
  }, [e, r]), F(R.Select, (i) => {
    const {
      value: o,
      trigger: {
        option: c,
        span: l,
        index: f,
        source: p
      }
    } = i, E = Pe(c.markup, o.label, o.value), C = cr(l, E, f, p), k = e.findNode((A) => A.mark.label === l);
    k && (k.data.mark.label = C, t.send(R.Change, {
      value: {
        label: C
      },
      key: k.data.key
    }));
  }, [e, r]);
}
function Dr(r) {
  const {
    value: e,
    children: t,
    ...n
  } = r, {
    Overlay: i,
    spanStyle: o,
    spanClassName: c,
    style: l,
    className: f,
    readOnly: p,
    onChange: E,
    Mark: C
  } = n;
  return K(() => n, [i, o, c, l, f, p, E, C]);
}
const Ir = ({
  props: r,
  children: e
}) => {
  const t = Pr(r.children), n = ae(Ar.withExternalEventsFrom(r))[0], i = Dr(r), o = K(() => ({
    options: t,
    bus: n,
    props: i
  }), [t, i, n]);
  return /* @__PURE__ */ P(sr.Provider, {
    value: o,
    children: /* @__PURE__ */ P(jr, {
      value: r.value,
      onChange: r.onChange,
      children: e
    })
  });
};
function jr({
  value: r,
  children: e,
  onChange: t
}) {
  const {
    options: n
  } = O(), i = Tr(r, n);
  return Nr(t, i), /* @__PURE__ */ P(or.Provider, {
    value: i,
    children: e
  });
}
class Ne {
  static find(e) {
    if (L.isSelectedPosition)
      return new Ne().find(e);
  }
  constructor() {
    let e = L.getCurrentPosition();
    this.node = L.getSelectedNode(), this.span = L.getFocusedSpan(), this.dividedText = this.getDividedTextBy(e);
  }
  getDividedTextBy(e) {
    return {
      left: this.span.slice(0, e),
      right: this.span.slice(e)
    };
  }
  find(e) {
    for (let t of e) {
      let n = this.matchInTextVia(t.trigger);
      if (n)
        return {
          value: n.word,
          source: n.annotation,
          index: n.index,
          span: this.span,
          node: this.node,
          option: t
        };
    }
  }
  matchInTextVia(e) {
    const t = this.matchRightPart(), n = this.matchLeftPart(e);
    if (n)
      return {
        word: n.word + t.word,
        annotation: n.annotation + t.word,
        index: n.index
      };
  }
  matchRightPart() {
    var t;
    const {
      right: e
    } = this.dividedText;
    return {
      word: (t = e.match(Xt)) == null ? void 0 : t[0]
    };
  }
  matchLeftPart(e) {
    var l;
    const t = this.makeTriggerRegex(e), {
      left: n
    } = this.dividedText, i = n.match(t);
    if (!i)
      return;
    const [o, c] = i;
    return {
      word: c,
      annotation: o,
      index: (l = i.index) != null ? l : 0
    };
  }
  makeTriggerRegex(e) {
    const t = he(e) + "(\\w*)$";
    return new RegExp(t);
  }
}
const Fr = () => {
  const [r, e] = ae(), {
    options: t
  } = O();
  return F(R.ClearTrigger, (n) => e(void 0), []), F(R.CheckTrigger, (n) => e(Ne.find(t)), [t]), r;
}, Lr = qt(({
  trigger: r,
  style: e,
  onSelect: t
}, n) => {
  const [i, o] = ae(NaN), c = K(() => r.option.data.filter((l) => l.toLowerCase().indexOf(r.value.toLowerCase()) > -1), [r.value]);
  return c.length ? /* @__PURE__ */ P("ul", {
    ref: n,
    className: "mk-suggestions",
    style: e,
    children: c.map((l, f) => {
      let p;
      return f === i && (p = "mk-suggestion-active"), /* @__PURE__ */ P("li", {
        className: p,
        onClick: (E) => t({
          label: l,
          value: f.toString()
        }),
        children: l
      }, l);
    })
  }) : null;
});
function Mr(r) {
  var c, l, f;
  const {
    bus: e
  } = O(), t = J(() => e.send(R.ClearTrigger), []), n = J((p) => e.send(R.Select, {
    value: p,
    trigger: r
  }), [r]), i = L.getAbsolutePosition(), o = {
    trigger: r,
    style: i,
    onSelect: n,
    onClose: t
  };
  return (f = (l = (c = r.option).initOverlay) == null ? void 0 : l.call(c, o)) != null ? f : o;
}
function Wr(r) {
  const {
    bus: e
  } = O();
  ie(() => {
    const t = (n) => {
      let i = n.target;
      i !== r.current && i !== e.get("TextRef").current && (i == null ? void 0 : i.parentElement) !== e.get("TextRef").current && e.send(R.ClearTrigger);
    };
    return document.addEventListener("click", t), () => document.removeEventListener("click", t);
  }, []);
}
function $r() {
  const {
    bus: r
  } = O();
  ie(() => {
    const e = (t) => {
      t.key === Y.ESC && r.send(R.ClearTrigger);
    };
    return window.addEventListener("keydown", e), () => window.removeEventListener("keydown", e);
  }, []);
}
const Br = (r) => {
  const e = G(null);
  $r(), Wr(e);
  const t = Mr(r), {
    props: {
      Overlay: n = Lr
    }
  } = O();
  return /* @__PURE__ */ P(n, {
    ref: e,
    ...t
  });
};
function Vr() {
  const {
    bus: r
  } = O(), e = J(ur(() => r.send(R.CheckTrigger), 20), []);
  F("onFocus", (t) => document.addEventListener("selectionchange", e, {}), []), F("onBlur", (t) => document.removeEventListener("selectionchange", e), []);
}
const Ur = ct(() => {
  Vr();
  const r = Fr();
  return r ? /* @__PURE__ */ P(Br, {
    ...r
  }, r.option.index) : null;
});
function Yr(r) {
  return /* @__PURE__ */ wr(Ir, {
    props: r,
    children: [/* @__PURE__ */ P(Sr, {}), /* @__PURE__ */ P(Ur, {})]
  });
}
const Gr = ({
  trigger: r = "@",
  markup: e = "@[__label__](__value__)",
  data: t = [],
  ...n
}) => null;
function Hr(r, e, t) {
  const n = rr(e) ? {
    Mark: r,
    Overlay: e,
    children: t
  } : {
    Mark: r,
    children: e
  };
  return (i) => {
    const o = ft({}, i, n);
    return Yr(o);
  };
}
export {
  Yr as MarkedInput,
  Gr as Option,
  Pe as annotate,
  Hr as createMarkedInput,
  Kr as denote,
  Cr as useMark
};
//# sourceMappingURL=index.js.map
